<!DOCTYPE html>
<html>

<head>
    <meta charset="UTF-8">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container mt-4">
        <h2>Lucky Dice History</h2>
        <div class="form-group">
            <label for="username">User name:</label>
            <input type="email" class="form-control" id="input-username" placeholder="Enter username" name="username">
        </div>
        <div class="form-group">
            <button type="button" class="btn btn-primary" onClick="onBtnShowDiceHistoryTableClick();">Show Dice History
                Table</button>
        </div>
        <div id="log-result" class="mt-5"></div>
        <div class="mt-5">
            <table id="table-dice-history" class="table table-striped table-bordered table-hover">
                <thead>
                    <tr>
                        <th>Game</th>
                        <th>Dice</th>
                    </tr>
                </thead>
                <tbody id = "table-body">
                    <!-- cấu trúc của bảng
                        Bao gồm nhiều dòng, mỗi dòng được định nghĩa thông qua 1 cặp thẻ <tr>...</tr>
                        Trong 1 dòng có thể có nhiều ô, mỗi ô được định nghĩa thông qua 1 cặp thẻ <td>...</td>
                        Dữ liệu hiển thị phải được đặt giữa cặp thẻ <td>...</td>

                    -->
                    <tr>
                        <td>Nội dung ô 1 dòng 1</td>
                        <td>Nội dung ô 2 dòng 1</td>
                    </tr>
                    <tr>
                        <td>Nội dung ô 1 dòng 2</td>
                        <td>Nội dung ô 2 dòng 2</td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>

    <script>
        'use strict';
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gEND_OF_ROW_COL = -1;
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Khai báo hàm xử lý sự kiện lên nút bấm show dice history table.
        function onBtnShowDiceHistoryTableClick() {
            var vPersonObject = {
                userName: ""
            }
            // Bước 1: Thu thập dữ liệu
            collectData(vPersonObject);
            //console.log (vPersonObject.userName);
            // Bước 2: Kiểm tra dữ liệu, nếu dữ liệu OK thì thực hiện bước 3 và 4
            var vValidateData = validateData(vPersonObject);
            if (vValidateData) {
                var vXmlHttpDiceHistory = new XMLHttpRequest();
                // Bước 3: Gọi API, lấy dữ liệu về
                callAPIGetDiceHistory(vXmlHttpDiceHistory, vPersonObject);
                vXmlHttpDiceHistory.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        // Bước 4: Xử lý dữ liệu trả về và hiển thị.
                        displayResponseData(vXmlHttpDiceHistory);
                    }
                }
            }

        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thu thập dữ liệu và đẩy vào biến personObject
        function collectData(paramPersonObject) {
            var vInputUsernameElement = document.getElementById("input-username");
            paramPersonObject.userName = vInputUsernameElement.value.trim();
        }

        // Hàm kiểm tra dữ liệu
        function validateData(paramPersonObject) {
            if (paramPersonObject.userName.length == 0) {
                alert("Bạn cần phải nhập username");
                return false;
            }
            return true;
        }

        // Hàm gọi API lấy dice history
        function callAPIGetDiceHistory(paramXmlHttpRequest, paramPersonObject) {
            paramXmlHttpRequest.open("GET", gBASE_URL + "/dice-history?username=" + paramPersonObject.userName, true);
            paramXmlHttpRequest.send();
        }

        // Hàm xử lý kết quả trả về và hiển thị dữ liệu

        function displayResponseData(paramXmlHttpRequest) {
            console.log(paramXmlHttpRequest.responseText);
            var vDiceHistoryString = paramXmlHttpRequest.responseText;
            var vDiceHistoryObject = JSON.parse(vDiceHistoryString);
            console.log(vDiceHistoryObject.dices);
            var vDiceHistoryArray = vDiceHistoryObject.dices;
            /* Phiên bản 1: cộng dồn thành chuỗi HTML và đẩy vào phần innerHTML của thẻ tbody
            var vHtml = '';
            for (var bIndex = 0; bIndex < vDiceHistoryArray.length; bIndex ++){
                vHtml += `
                    <tr>
                        <td>${bIndex + 1}</td>
                        <td>${vDiceHistoryArray[bIndex]}</td>
                    </tr>
                `;
            }
            document.getElementById("table-body").innerHTML = vHtml;
            */
            /* Phiên bản 2: Sử dụng các phương thức insertRow và insertCell (chỉ áp dụng cho bảng)
            var vTBodyElement = document.getElementById("table-body");
            vTBodyElement.innerHTML = "";
            for (var bIndex = 0; bIndex < vDiceHistoryArray.length; bIndex ++){
                var bNewRow = vTBodyElement.insertRow(gEND_OF_ROW_COL);
                var bNewCell1 = bNewRow.insertCell(0); 
                var bNewCell2 = bNewRow.insertCell(1);
                bNewCell1.innerHTML = bIndex + 1;
                bNewCell2.innerHTML = vDiceHistoryArray[bIndex];
            }
            */
            // Phiên bản 3: dùng document.createElement để tạo thẻ mới.
            var vTBodyElement = document.getElementById("table-body");
            vTBodyElement.innerHTML = "";
            for (var bIndex = 0; bIndex < vDiceHistoryArray.length; bIndex ++){
                // Tạo thẻ tr mới thông qua phương thức document.createElement 
                var bNewRow = document.createElement("tr");
                // Gắn thẻ tr mới tạo vào phía cuối của thẻ cha thông qua phương thức: bienTheCha.append(bienTheMoi)
                vTBodyElement.appendChild(bNewRow);
                var bNewCell1 = document.createElement("td");
                bNewCell1.innerHTML = bIndex + 1;
                bNewRow.appendChild(bNewCell1);
                var bNewCell2 = document.createElement("td");
                bNewCell2.innerHTML = vDiceHistoryArray[bIndex];
                bNewRow.appendChild(bNewCell2);
            }
        }
    </script>


</body>

</html>